PNPDUMP(8)

NAME
pnpdump - Dump ISA Plug-And-Play devices resource information

SYNOPSIS
pnpdump [ --config ] [ --script[=outputfile] ] [ --reset ] [ --showmasks ] [ [ devs ] readport ]

DESCRIPTION
pnpdump will scan all the ISA PnP cards, dumping their resource data to stdout. The resource data is supposed to be a description of the resources (IO ports, interrupts, DMA channels) that the card would like, or needs, to use to work. It is stored in a small ROM on the card, which can be read as part of the Plug and Play configuration process.
Note that some manufacturers are rather lax about the contents of this ROM, particularly if the card is not required for booting, so the resource data may not be accurate. As they also typically provide a DOS/Windows driver for the card, they really only need to be able to recognise it, as the driver can then complete the configuration.
The output of pnpdump is in a form that can be used by isapnp, except that the actual configuration statements are commented out. See isapnp.conf(5) for details of the format.
By default, pnpdump will reset all the Card Serial Numbers, then ISOLATE each one and allocate it a handle (Card Select Number). This process will include trying different readport addresses until a suitable one is found avoiding conflicts with other hardware. For a description of what the readport is, see the relevant entry in isapnp.conf(5). As of the isapnptools 1.12 release, any existing configuration settings will be unaffected.
If a single parameter is provided, this will be used as the minimum readport address to start scanning. This may be chosen to avoid an unfortunate conflict.
To skip the Isolation process, both additional parameters may be supplied:

  Parameters

devs is the number of PnP cards that the BIOS has found,
    ISOLATEd and allocated CSNs to in the system. Note that if this is greater than the actual number of cards in the system, pnpdump will stop scanning when it receives a first serial identifier byte of 0xff (this is what happens when there isn't a card with that CSN).
    If this parameter is provided, then pnpdump will not ISOLATE each card and assign CSNs, however, the readport provided must be the same as the one the BIOS used. This could be difficult to determine if it is not assigned via a BIOS setup screen.

readport is the address of the readport to use for the
    Plug-And-Play access. The number base is determined by the format: a leading 0x implies hex, a leading 0 implies octal, otherwise decimal is assumed.
    The address of the readport must be chosen to avoid any conflicts with existing (non Plug and Play) hardware, and must be in the range 0x203..0x3ff.
    If the readport is specified without devs, then this is the minimum readport to use when scanning for a suitable one.

Note that for the two parameter option to work, you must have a PnP BIOS which has already carried out the ISOLATION process correctly, and you must know what readport address the BIOS used.

  Options

-c, --config
    attempt to determine safe settings to which the devices can be set, and uncomment those settings in the output. pnpdump will use the /proc filesystem and the lspci program to discover system resources that have already been allocated if these facilities are available on the system.
    Note that this executes an external program 'lspci' using popen, so care must be taken when invoking with this option to prevent a root compromise.

-r, --reset
    Carry out a full configuration reset, rather than just resetting the CSNs. DANGEROUS as this could reset PnP boards in active use by the kernel, resulting in a lockup or worse.

-s, --showmasks
    Print the lists of acceptable interrupts and direct memory access (DMA) channels as binary bitmasks. For example, print "IRQ mask 0x03" instead of "IRQ 1, 2, or 3".

--script[=outputscript]
    write a shell script to the specified file that can be used to configure the system based on what ISA PnP boards were found and how they were configured.
    If --script is specified without an argument, then the script is piped (using popen) directly into a shell (sh) process. This is really useful only with --config.
    For each card, the script tries to execute the shell script /etc/pnp/config-scripts/isa/PRODUCT_ID or, failing that, /usr/share/pnp/config-scripts/isa/PRODUCT_ID. The generated shell script will try the compatible device ID's if any can any are in the ISA PnP information and no script for the device itself can be found.
    The /usr/share directory contents are the standard location, while the /etc directory is for you to put your customized versions of these scripts. You should write these shell scripts to generate the file /etc/conf.modules.isapnp at boot time, and then do something like "cat /etc/conf.modules.isapnp /etc/conf.modules.base > /etc/conf.modules", so that you can automatically configure the modules for the devices that you have.

FILES

/sbin/pnpdump
    The executable.

/etc/isapnp.conf
    The resting place of the editted output.

BUGS
Doesn't seem to work with newer computers, particularly with network cards. Cause unknown. If you think you have found one, please send a report to isapnp@roestock.demon.co.uk.

WARNING
This program can reset all your Plug-and-Play devices. Use at your own risk.

AUTHOR
pnpdump has been written by Peter Fox <fox@roestock.demon.co.uk>, the creator and maintainer of isapnptools.

AVAILABILITY
The latest version of the sources may be obtained by ftp from ftp://ftp.demon.co.uk/pub/unix/linux/utils
Or follow the pointer from my web page at http://www.roestock.demon.co.uk/isapnptools/

REFERENCES
Plug and Play ISA Specification, Version 1.0a, May 5, 1994. Available from ftp://ftp.microsoft.com/developer/drg/Plug-and-Play/Pnpspecs

SEE ALSO
isapnp(8), isapnp.conf(5)